/****************************************************************/
/*                                                              */
/*                   -------------------------                  */
/*------------------- 8042 Disassembler, V1.0 ------------------*/
/*                   -------------------------                  */
/*                                                              */
/*                     Author: Mark J. Foster                   */
/*                     Last Update:  6 Jun 88                   */
/*                                                              */
/****************************************************************/

#include "stdio.h"
#include "string.h"

#define OFS	0x0000		/* Offset to actual run location */

char *instbl[256] = {
	"NOP",
	"???",
	"OUT\tDBB,A",
	"ADD\tA,#%02XH",
	"JMP\tP0,%04XH",
	"EN\tI",
	"???",
	"DEC\tA",
	"INS\tA,BUS",
	"IN\tA,P1",
	"IN\tA,P2",
	"???",
	"MOVD\tA,P4",
	"MOVD\tA,P5",
	"MOVD\tA,P6",
	"MOVD\tA,P7",
	"INC\t@R0",
	"INC\t@R1",
	"JB0\t%04XH",
	"ADDC\tA,#%02XH",
	"CALL\tP0,%04XH",
	"DIS\tI",
	"JTF\t%04XH",
	"INC\tA",
	"INC\tR0",
	"INC\tR1",
	"INC\tR2",
	"INC\tR3",
	"INC\tR4",
	"INC\tR5",
	"INC\tR6",
	"INC\tR7",
	"XCH\tA,@R0",
	"XCH\tA,@R1",
	"IN\tA,DBB",
	"MOV\tA,#%02XH",
	"JMP\tP1,%04XH",
	"EN\tTCNTI",
	"JNT0\t%04XH",
	"CLR\tA",
	"XCH\tA,R0",
	"XCH\tA,R1",
	"XCH\tA,R2",
	"XCH\tA,R3",
	"XCH\tA,R4",
	"XCH\tA,R5",
	"XCH\tA,R6",
	"XCH\tA,R7",
	"XCHD\tA,@R0",
	"XCHD\tA,@R1",
	"JB1\t%04XH",
	"???",
	"CALL\tP1,%04XH",
	"DIS\tTCNTI",
	"JT0\t%04XH",
	"CPL\tA",
	"???",
	"OUTL\tP1,A",
	"OUTL\tP2,A",
	"???",
	"MOVD\tP4,A",
	"MOVD\tP5,A",
	"MOVD\tP6,A",
	"MOVD\tP7,A",
	"ORL\tA,@R0",
	"ORL\tA,@R1",
	"MOV\tA,T",
	"ORL\tA,#%02XH",
	"JMP\tP2,%04XH",
	"STRT\tCNT",
	"JNT1\t%04XH",
	"SWAP\tA",
	"ORL\tA,R0",
	"ORL\tA,R1",
	"ORL\tA,R2",
	"ORL\tA,R3",
	"ORL\tA,R4",
	"ORL\tA,R5",
	"ORL\tA,R6",
	"ORL\tA,R7",
	"ANL\tA,@R0",
	"ANL\tA,@R1",
	"JB2\t%04XH",
	"ANL\tA,#%02XH",
	"CALL\tP2,%04XH",
	"STRT\tT",
	"JT1\t%04XH",
	"DA\tA",
	"ANL\tA,R0",
	"ANL\tA,R1",
	"ANL\tA,R2",
	"ANL\tA,R3",
	"ANL\tA,R4",
	"ANL\tA,R5",
	"ANL\tA,R6",
	"ANL\tA,R7",
	"ADD\tA,@R0",
	"ADD\tA,@R1",
	"MOV\tT,A",
	"???",
	"JMP\tP3,%04XH",
	"STOP\tTCNT",
	"???",
	"RRC\tA",
	"ADD\tA,R0",
	"ADD\tA,R1",
	"ADD\tA,R2",
	"ADD\tA,R3",
	"ADD\tA,R4",
	"ADD\tA,R5",
	"ADD\tA,R6",
	"ADD\tA,R7",
	"ADDC\tA,@R0",
	"ADDC\tA,@R1",
	"JB3\t%04XH",
	"???",
	"CALL\tP3,%04XH",
	"ENT0\tCLK",
	"JF1\t%04XH",
	"RR\tA",
	"ADDC\tA,R0",
	"ADDC\tA,R1",
	"ADDC\tA,R2",
	"ADDC\tA,R3",
	"ADDC\tA,R4",
	"ADDC\tA,R5",
	"ADDC\tA,R6",
	"ADDC\tA,R7",
	"MOVX\tA,@R0",
	"MOVX\tA,@R1",
	"???",
	"RET",			/* 83 */
	"JMP\tP4,%04XH",
	"CLR\tF0",
	"JOBF\t%04XH",
	"???",
	"ORL\tBUS,#%02XH",
	"ORL\tP1,#%02XH",
	"ORL\tP2,#%02XH",
	"???",
	"ORLD\tP4,A",
	"ORLD\tP5,A",
	"ORLD\tP6,A",
	"ORLD\tP7,A",
	"MOV\tSTS,A",		/* 90 */
	"MOVX\t@R1,A",
	"JB4\t%04XH",
	"RETR",
	"CALL\tP4,%04XH",
	"CPL\tF0",
	"JNZ\t%04XH",
	"CLR\tC",
	"ANL\tBUS,#%02XH",
	"ANL\tP1,#%02XH",
	"ANL\tP2,#%02XH",
	"???",
	"ANLD\tP4,A",
	"ANLD\tP5,A",
	"ANLD\tP6,A",
	"ANLD\tP7,A",
	"MOV\t@R0,A",
	"MOV\t@R1,A",
	"???",
	"MOVP\tA,@A",
	"JMP\tP5,%04XH",
	"CLR\tF1",
	"???",
	"CPL\tC",
	"MOV\tR0,A",
	"MOV\tR1,A",
	"MOV\tR2,A",
	"MOV\tR3,A",
	"MOV\tR4,A",
	"MOV\tR5,A",
	"MOV\tR6,A",
	"MOV\tR7,A",
	"MOV\t@R0,#%02XH",
	"MOV\t@R1,#%02XH",
	"JB5\t%04XH",
	"JMPP\t@A",
	"CALL\tP5,%04XH",
	"CPL\tF1",
	"JF0\t%04XH",
	"???",
	"MOV\tR0,#%02XH",
	"MOV\tR1,#%02XH",
	"MOV\tR2,#%02XH",
	"MOV\tR3,#%02XH",
	"MOV\tR4,#%02XH",
	"MOV\tR5,#%02XH",
	"MOV\tR6,#%02XH",
	"MOV\tR7,#%02XH",
	"???",
	"???",
	"???",
	"???",
	"JMP\tP6,%04XH",
	"SEL\tRB0",
	"JZ\t%04XH",
	"MOV\tA,PSW",
	"DEC\tR0",		/* D0 */
	"DEC\tR1",
	"DEC\tR2",
	"DEC\tR3",
	"DEC\tR4",
	"DEC\tR5",
	"DEC\tR6",
	"DEC\tR7",
	"XRL\tA,@R0",
	"XRL\tA,@R1",
	"JB6\t%04XH",
	"XRL\tA,#%02XH",
	"CALL\tP6,%04XH",
	"SEL\tRB1",
	"JNIBF\t%04XH",
	"MOV\tPSW,A",
	"XRL\tA,R0",
	"XRL\tA,R1",
	"XRL\tA,R2",
	"XRL\tA,R3",
	"XRL\tA,R4",
	"XRL\tA,R5",
	"XRL\tA,R6",
	"XRL\tA,R7",
	"???",			/* E0 */
	"???",
	"???",
	"MOVP3\tA,@A",
	"JMP\tP7,%04XH",
	"EN\tDMA",
	"JNC\t%04XH",
	"RL\tA",
	"DJNZ\tR0,%04XH",
	"DJNZ\tR1,%04XH",
	"DJNZ\tR2,%04XH",
	"DJNZ\tR3,%04XH",
	"DJNZ\tR4,%04XH",
	"DJNZ\tR5,%04XH",
	"DJNZ\tR6,%04XH",
	"DJNZ\tR7,%04XH",
	"MOV\tA,@R0",		/* F0 */
	"MOV\tA,@R1",
	"JB7\t%04XH",
	"???",
	"CALL\tP7,%04XH",
	"EN\tFLAGS",
	"JC\t%04XH",
	"RLC\tA",
	"MOV\tA,R0",
	"MOV\tA,R1",
	"MOV\tA,R2",
	"MOV\tA,R3",
	"MOV\tA,R4",
	"MOV\tA,R5",
	"MOV\tA,R6",
	"MOV\tA,R7" };


unsigned char mem[4 * 1024];	/* Memory image being disassembled */
unsigned char outbuff[132];	/* Output line buffer */
unsigned char insbuff[132];	/* Individual instruction buffer */
int lc;				/* Current location counter */
FILE *inf;			/* Input file */
FILE *of;			/* Output file */

main(argc, argv)
    int argc;  char *argv[];
{   int i, count;
    if (argc != 3) help();
    if (!(inf  = fopen(argv[1], "rb"))) error("Can't open input file!");
    if (!(of = fopen(argv[2], "w"))) error("Can't open output file!");
    if ((count = fread(mem, 1, sizeof(mem), inf)) == 0) error("Can't read input file!");
    fputs("--- Page 0 ---\n", of);
    lc = 0;					/* Reset location counter */
    while (lc < count) {			/* Walk through each byte of code */
	if (mem[lc] == 0xFF) {			/* At end of page? */
	    for (i = lc & 0xFF;  i <= 0xFF;  ++i) {
	        if (mem[(lc & 0xFF00) | i] != 0xFF) break;
		}
	    if (i >= 0x100) {			/* No more good code in page */
		lc = (lc | 0xFF) + 1;		/* Point to the next page */
		fprintf(of, "\014--- Page %d ---\n", lc >> 8);
		}
	    }
	disins();				/* Disassemble an instruction */
	}
    fclose(inf);				/* Close the input file */
    fclose(of);					/* Close the output file */
    } /* main */

disins()
{   unsigned char *ip;
    unsigned char ins;				/* Current instruction byte */
    int slc;					/* Start locptr for instruction */
    int temp;
    slc = lc;					/* Set start-of-ins ptr */
    ins = mem[lc++];				/* Read the current opcode */
    if (ip = strchr(instbl[ins], '%')) {	/* Special cased instruction */
	if (strncmp(ip, "%02X", 4) == 0) {	/* Have an immediate data byte */
	    sprintf(insbuff, instbl[ins], mem[lc++]); /* Write instruction to output */
	    outs(insbuff);			/* Output the string */
	    outln(slc, lc);			/* Finish the line */
	    }
	if (strncmp(ip, "%04X", 4) == 0) {	/* Have a target address */
	    ++lc;				/* Point past immediate data byte */
	    if ((ins & 0x1F) == 0x04 || (ins & 0x1F) == 0x14) {
		sprintf(insbuff,instbl[ins],((ins & 0xE0) << 3) | mem[lc-1]);
		}
	    else sprintf(insbuff, instbl[ins], (lc & 0xFF00) | mem[lc-1]);
	    outs(insbuff);			/* Output the string */
	    outln(slc, lc);			/* Finish the line */
	    }
        }
    else {
	outs(instbl[ins]);			/* Write simple instructions */
	outln(slc, lc);				/* Output the line */
	}
    if ((ins & 0x1F) == 0x04 || ins == 0x83 || ins == 0x93) { /* Control transfer */
	fputs("\n", of);			/* Write a blank line to separate */
	}
    } /* disins */

outln(start, end)
{   int i, len;
    fprintf(of, "%04XH ", start + OFS);		/* Write the output address */
    len = end - start;				/* Get length of opcode */
    for (i = 0;  i < len;  ++i) {		/* Display opcodes in hex */
	fprintf(of, "%02X ", mem[start + i]);	/* Display a hex byte */
	}
    while (len < 4) {				/* Pad remaining spaces */
	fputs("   ", of);			/* Pad past unused byte */
	++len;					/* Count this byte posn */
	}
    fputs("\t", of);				/* Write a trailing TAB */
    fputs(outbuff, of);				/* Write disassembled instruction */
    fputs("\n", of);				/* Terminate the line */
    outbuff[0] = '\0';				/* Clear output buffer */
    } /* outln */

outnum(value, len)
    int value, len;
{   char buff[80];
    switch(len) {
	case 2: sprintf(buff, "$%02X", value);	/* Write a byte value */
		break;
	case 4: sprintf(buff, "$%04X", value);	/* Write word value */
		break;
	default: sprintf(buff, "%d", value);	/* Write decimal number */
		break;
	}
    strcat(outbuff, buff);			/* Write string to output */
    } /* outnum */

outs(str)
    char *str;
{   strcat(outbuff, str);
    } /* outs */


error(str)
    char *str;
{   puts(str);
    exit(1);
    } /* error */

help()
{   puts("Intel 8042 Disassembler, V1.0\n");
    puts("Syntax: DISASM42 <infile> <listfile>");
    } /* help */

